//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Main.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
	: TForm(Owner)
{
}

void __fastcall TMainForm::GrowItem(TMessage &Message) {
	int wapp;

	if (ProgressBar1->Position >= ProgressBar1->Max) {
		ProgressBar1->Position = 0;
	} else {
		ProgressBar1->StepIt();
	}
	wapp = HIWORD(GetQueueStatus(QS_POSTMESSAGE));
	if (wapp > 5) {
		Shape1->Brush->Color = clRed;
		while (wapp-- > 5) {
			MSG msg;
			GetMessage(&msg, NULL, WM_APP, WM_APP);
		}
	} else if (wapp > 2) {
		Shape1->Brush->Color = clYellow;
	} else {
		Shape1->Brush->Color = clGreen;
	}
}

static bool sendMsg = true;

static void CALLBACK myProc(
    UINT uID,
    UINT uMsg,
    DWORD dwUser,
    DWORD dw1,
    DWORD dw2
) {
	if (sendMsg) {
		PostMessage((HWND)dwUser, WM_APP, 0, 0);
	}
}

void __fastcall TMainForm::Start(void)
{
	AnsiString t1;
	int p1, p2;

	t1 = Edit1->Text;
	p1 = strtoul(t1.c_str(), NULL, 0);
	t1 = Edit2->Text;
	p2 = strtoul(t1.c_str(), NULL, 0);

	mmr = timeSetEvent(p1, p2, myProc, (DWORD)Handle, TIME_PERIODIC);
	if (mmr) {
		running = true;
		LError->Visible = false;
		t1.sprintf("Timer %08X is running", mmr);
		LError->Caption = t1;
		LError->Font->Color = clGreen;
		LError->Visible = true;
		Button1->Caption = "Stop";
	} else {
		LError->Visible = false;
		t1.sprintf("Multimedia Error %08X", mmr);
		LError->Caption = t1;
		LError->Font->Color = clRed;
		LError->Visible = true;
	}
}

void __fastcall TMainForm::Stop(void)
{
	if (running) {
		MMRESULT m;

		m = timeKillEvent(mmr);
		if (m == TIMERR_NOERROR) {
			LError->Visible = false;
			Shape1->Brush->Color = clGreen;
			Button1->Caption = "Start";
			running = false;
		} else {
			AnsiString t1;

			LError->Visible = false;
			t1.sprintf("Multimedia Error %08X", m);
			LError->Caption = t1;
			LError->Font->Color = clRed;
			LError->Visible = true;
		}
	}
}
//----------------------------------------------------------------------------
void __fastcall TMainForm::Button1Click(TObject *Sender)
{
	if (running) {
		Stop();
	} else {
		Start();
	}
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
	Stop();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormResize(TObject *Sender)
{
	ProgressBar1->Max = ProgressBar1->Width;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CheckBox1Click(TObject *Sender)
{
	sendMsg = CheckBox1->Checked;
}
//---------------------------------------------------------------------------

